diff --git a/.appveyor.yml b/.appveyor.yml
index db6ba5e866..7413b7f4d0 100644
--- a/.appveyor.yml
+++ b/.appveyor.yml
@@ -9,6 +9,7 @@ branches:
 
 environment:
   matrix:
+  - llvm: 4.0.0
   - llvm: 3.9.1
   - llvm: 3.8.1
   - llvm: 3.7.1
diff --git a/.travis.yml b/.travis.yml
index 6ea250a8d9..3b933e6c55 100644
--- a/.travis.yml
+++ b/.travis.yml
@@ -113,6 +113,36 @@ matrix:
         - ICC1=gcc-6
         - ICXX1=g++-6
 
+    - os: linux
+      addons:
+        apt:
+          sources:
+            - ubuntu-toolchain-r-test
+          packages:
+            - g++-6
+      env:
+        - FAVORITE_CONFIG=no
+        - LLVM_VERSION="4.0.0"
+        - LLVM_CONFIG="llvm-config-4.0"
+        - config=debug
+        - CC1=gcc-6
+        - CXX1=g++-6
+
+    - os: linux
+      addons:
+        apt:
+          sources:
+            - ubuntu-toolchain-r-test
+          packages:
+            - g++-6
+      env:
+        - FAVORITE_CONFIG=yes
+        - LLVM_VERSION="4.0.0"
+        - LLVM_CONFIG="llvm-config-4.0"
+        - config=release
+        - CC1=gcc-6
+        - CXX1=g++-6
+
     - os: osx
       env:
         - FAVORITE_CONFIG=no
@@ -170,6 +200,25 @@ matrix:
         - CC1=clang-3.9
         - CXX1=clang++-3.9
 
+    - os: osx
+      env:
+        - FAVORITE_CONFIG=no
+        - LLVM_VERSION="4.0.0"
+        - LLVM_CONFIG="llvm-config-4.0"
+        - config=debug
+        - CC1=clang-3.9
+        - CXX1=clang++-3.9
+
+    - os: osx
+      env:
+        - FAVORITE_CONFIG=no
+        - LLVM_VERSION="3.9.1"
+        - LLVM_CONFIG="llvm-config-4.0"
+        - config=release
+        - lto=no
+        - CC1=clang-3.9
+        - CXX1=clang++-3.9
+
 rvm:
   - 2.2.3
 
diff --git a/Makefile b/Makefile
index b44106721c..676fa6b6fa 100644
--- a/Makefile
+++ b/Makefile
@@ -193,10 +193,14 @@ ifeq ($(OSTYPE),osx)
 endif
 
 ifndef LLVM_CONFIG
-	ifneq (,$(shell which /usr/local/opt/llvm@3.9/bin/llvm-config 2> /dev/null))
-    LLVM_CONFIG = /usr/local/opt/llvm@3.9/bin/llvm-config
-    LLVM_LINK = /usr/local/opt/llvm@3.9/bin/llvm-link
-    LLVM_OPT = /usr/local/opt/llvm@3.9/bin/opt
+	ifneq (,$(shell which /usr/local/opt/llvm@4.0/bin/llvm-config 2> /dev/null))
+    LLVM_CONFIG = /usr/local/opt/llvm@4.0/bin/llvm-config
+    LLVM_LINK = /usr/local/opt/llvm@4.0/bin/llvm-link
+    LLVM_OPT = /usr/local/opt/llvm@4.0/bin/opt
+  else ifneq (,$(shell which llvm-config-4.0 2> /dev/null))
+    LLVM_CONFIG = llvm-config-4.0
+    LLVM_LINK = llvm-link-4.0
+    LLVM_OPT = opt-4.0
   else ifneq (,$(shell which llvm-config-3.9 2> /dev/null))
     LLVM_CONFIG = llvm-config-3.9
     LLVM_LINK = llvm-link-3.9
@@ -267,9 +271,10 @@ endif
 ifeq ($(llvm_version),3.7.1)
 else ifeq ($(llvm_version),3.8.1)
 else ifeq ($(llvm_version),3.9.1)
+else ifeq ($(llvm_version),4.0.0)
 else
   $(warning WARNING: Unsupported LLVM version: $(llvm_version))
-  $(warning Please use LLVM 3.7.1, 3.8.1, or 3.9.1)
+  $(warning Please use LLVM 3.7.1, 3.8.1, 3.9.1, or 4.0.0)
 endif
 
 compiler_version := "$(shell $(CC) --version | sed -n 1p)"
diff --git a/src/libponyc/codegen/codegen.h b/src/libponyc/codegen/codegen.h
index adff76e5ab..84882426ff 100644
--- a/src/libponyc/codegen/codegen.h
+++ b/src/libponyc/codegen/codegen.h
@@ -41,6 +41,8 @@ LLVMValueRef LLVMConstInf(LLVMTypeRef type, bool negative);
 LLVMModuleRef LLVMParseIRFileInContext(LLVMContextRef ctx, const char* file);
 bool LLVMHasMetadataStr(LLVMValueRef val, const char* str);
 void LLVMSetMetadataStr(LLVMValueRef val, const char* str, LLVMValueRef node);
+void LLVMMDNodeReplaceOperand(LLVMValueRef parent, unsigned i,
+  LLVMValueRef node);
 
 // Intrinsics.
 LLVMValueRef LLVMMemcpy(LLVMModuleRef module, bool ilp32);
@@ -184,8 +186,10 @@ typedef struct compile_t
   LLVMDIBuilderRef di;
   LLVMMetadataRef di_unit;
   LLVMValueRef tbaa_root;
+#if LLVM_PONY < 400
   LLVMValueRef tbaa_descriptor;
   LLVMValueRef tbaa_descptr;
+#endif  
   LLVMValueRef none_instance;
   LLVMValueRef primitives_init;
   LLVMValueRef primitives_final;
diff --git a/src/libponyc/codegen/genbox.c b/src/libponyc/codegen/genbox.c
index b4fbe7ef3f..a294f61a8d 100644
--- a/src/libponyc/codegen/genbox.c
+++ b/src/libponyc/codegen/genbox.c
@@ -31,8 +31,12 @@ LLVMValueRef gen_box(compile_t* c, ast_t* type, LLVMValueRef value)
 
   const char* box_name = genname_box(t->name);
   LLVMValueRef metadata = tbaa_metadata_for_box_type(c, box_name);
+#if PONY_LLVM >= 400
+  tbaa_tag(c, metadata, store);
+#else
   const char id[] = "tbaa";
   LLVMSetMetadata(store, LLVMGetMDKindID(id, sizeof(id) - 1), metadata);
+#endif
 
   return this_ptr;
 }
@@ -60,8 +64,12 @@ LLVMValueRef gen_unbox(compile_t* c, ast_t* type, LLVMValueRef object)
 
   const char* box_name = genname_box(t->name);
   LLVMValueRef metadata = tbaa_metadata_for_box_type(c, box_name);
+#if PONY_LLVM >= 400
+  tbaa_tag(c, metadata, value);
+#else
   const char id[] = "tbaa";
   LLVMSetMetadata(value, LLVMGetMDKindID(id, sizeof(id) - 1), metadata);
+#endif
 
   return gen_assign_cast(c, c_t->use_type, value, t->ast_cap);
 }
diff --git a/src/libponyc/codegen/gendebug.cc b/src/libponyc/codegen/gendebug.cc
index cd55089e77..dc13530119 100644
--- a/src/libponyc/codegen/gendebug.cc
+++ b/src/libponyc/codegen/gendebug.cc
@@ -69,16 +69,20 @@ LLVMMetadataRef LLVMDIBuilderCreateCompileUnit(LLVMDIBuilderRef d,
   unsigned lang, const char* file, const char* dir, const char* producer,
   int optimized)
 {
-#if PONY_LLVM >= 309
   DIBuilder* pd = unwrap(d);
-
+  const StringRef flags = "";
+  const unsigned runtimever = 0;
+
+#if PONY_LLVM >= 400
+  DIFile* difile = pd->createFile(file, dir);
+  return wrap(pd->createCompileUnit(lang, difile, producer, 
+    optimized ? true : false, flags, runtimever));
+#elif PONY_LLVM >= 309
   return wrap(pd->createCompileUnit(lang, file, dir, producer, optimized,
-    StringRef(), 0, StringRef())); // use the defaults
+    flags, runtimever, StringRef())); // use the defaults
 #else
-  DIBuilder* pd = unwrap(d);
-
   return wrap(pd->createCompileUnit(lang, file, dir, producer, optimized,
-    StringRef(), 0, StringRef(), DIBuilder::FullDebug, 0, true));
+    flags, runtimever, StringRef(), DIBuilder::FullDebug, 0, true));
 #endif
 }
 
@@ -106,26 +110,31 @@ LLVMMetadataRef LLVMDIBuilderCreateMethod(LLVMDIBuilderRef d,
   LLVMMetadataRef file, unsigned line, LLVMMetadataRef type, LLVMValueRef func,
   int optimized)
 {
-#if PONY_LLVM >= 308
   DIBuilder* pd = unwrap(d);
   Function* f = unwrap<Function>(func);
 
+#if PONY_LLVM >= 400
   DISubprogram* di_method = pd->createMethod(unwrap<DIScope>(scope),
     name, linkage, unwrap<DIFile>(file), line, unwrap<DISubroutineType>(type),
-    false, true, 0, 0,
-#  if PONY_LLVM >= 309
-    0,
-#  else
-    nullptr,
-#  endif
-    0, optimized);
+    false, true, 0, 0, 0, nullptr, DINode::FlagZero, optimized ? true : false);
 
   f->setSubprogram(di_method);
   return wrap(di_method);
-#else
-  DIBuilder* pd = unwrap(d);
-  Function* f = unwrap<Function>(func);
+#elif PONY_LLVM >= 309
+  DISubprogram* di_method = pd->createMethod(unwrap<DIScope>(scope),
+    name, linkage, unwrap<DIFile>(file), line, unwrap<DISubroutineType>(type),
+    false, true, 0, 0, 0, 0, optimized);
 
+  f->setSubprogram(di_method);
+  return wrap(di_method);
+#elif PONY_LLVM >= 308
+  DISubprogram* di_method = pd->createMethod(unwrap<DIScope>(scope),
+    name, linkage, unwrap<DIFile>(file), line, unwrap<DISubroutineType>(type),
+    false, true, 0, 0, nullptr, 0, optimized);
+
+  f->setSubprogram(di_method);
+  return wrap(di_method);
+#else
   return wrap(pd->createMethod(unwrap<DIScope>(scope), name, linkage,
     unwrap<DIFile>(file), line, unwrap<DISubroutineType>(type),
     false, true, 0, 0, nullptr, 0, optimized, f));
@@ -136,14 +145,15 @@ LLVMMetadataRef LLVMDIBuilderCreateAutoVariable(LLVMDIBuilderRef d,
   LLVMMetadataRef scope, const char* name, LLVMMetadataRef file,
   unsigned line, LLVMMetadataRef type)
 {
-#if PONY_LLVM >= 308
   DIBuilder* pd = unwrap(d);
 
+#if PONY_LLVM >= 400
+  return wrap(pd->createAutoVariable(unwrap<DIScope>(scope), name,
+    unwrap<DIFile>(file), line, unwrap<DIType>(type), true, DINode::FlagZero));
+#elif PONY_LLVM >= 308
   return wrap(pd->createAutoVariable(unwrap<DIScope>(scope), name,
     unwrap<DIFile>(file), line, unwrap<DIType>(type), true, 0));
 #else
-  DIBuilder* pd = unwrap(d);
-
   return wrap(pd->createLocalVariable(DW_TAG_auto_variable,
     unwrap<DIScope>(scope), name, unwrap<DIFile>(file), line,
     unwrap<DIType>(type), true, 0));
@@ -154,15 +164,17 @@ LLVMMetadataRef LLVMDIBuilderCreateParameterVariable(LLVMDIBuilderRef d,
   LLVMMetadataRef scope, const char* name, unsigned arg,
   LLVMMetadataRef file, unsigned line, LLVMMetadataRef type)
 {
-#if PONY_LLVM >= 308
   DIBuilder* pd = unwrap(d);
 
+#if PONY_LLVM >= 400
+  return wrap(pd->createParameterVariable(
+    unwrap<DIScope>(scope), name, arg, unwrap<DIFile>(file), line,
+    unwrap<DIType>(type), true, DINode::FlagZero));
+#elif PONY_LLVM >= 308
   return wrap(pd->createParameterVariable(
     unwrap<DIScope>(scope), name, arg, unwrap<DIFile>(file), line,
     unwrap<DIType>(type), true, 0));
 #else
-  DIBuilder* pd = unwrap(d);
-
   return wrap(pd->createLocalVariable(DW_TAG_arg_variable,
     unwrap<DIScope>(scope), name, unwrap<DIFile>(file), line,
     unwrap<DIType>(type), true, 0, arg));
@@ -195,7 +207,13 @@ LLVMMetadataRef LLVMDIBuilderCreateBasicType(LLVMDIBuilderRef d,
   unsigned encoding)
 {
   DIBuilder* pd = unwrap(d);
+
+#if PONY_LLVM >= 400
+  (void)(align_bits);
+  return wrap(pd->createBasicType(name, size_bits, encoding));
+#else
   return wrap(pd->createBasicType(name, size_bits, align_bits, encoding));
+#endif
 }
 
 LLVMMetadataRef LLVMDIBuilderCreatePointerType(LLVMDIBuilderRef d,
@@ -204,7 +222,7 @@ LLVMMetadataRef LLVMDIBuilderCreatePointerType(LLVMDIBuilderRef d,
   DIBuilder* pd = unwrap(d);
 
   return wrap(pd->createPointerType(unwrap<DIType>(elem_type), size_bits,
-    align_bits));
+    static_cast<uint32_t>(align_bits)));
 }
 
 LLVMMetadataRef LLVMDIBuilderCreateSubroutineType(LLVMDIBuilderRef d,
@@ -231,9 +249,16 @@ LLVMMetadataRef LLVMDIBuilderCreateStructType(LLVMDIBuilderRef d,
 {
   DIBuilder* pd = unwrap(d);
 
+#if PONY_LLVM >= 400
+  return wrap(pd->createStructType(unwrap<DIScope>(scope), name,
+    unwrap<DIFile>(file), line, size_bits, 
+    static_cast<uint32_t>(align_bits), DINode::FlagZero, nullptr,
+    elem_types ? DINodeArray(unwrap<MDTuple>(elem_types)) : nullptr));
+#else
   return wrap(pd->createStructType(unwrap<DIScope>(scope), name,
     unwrap<DIFile>(file), line, size_bits, align_bits, 0, nullptr,
     elem_types ? DINodeArray(unwrap<MDTuple>(elem_types)) : nullptr));
+#endif
 }
 
 LLVMMetadataRef LLVMDIBuilderCreateReplaceableStruct(LLVMDIBuilderRef d,
@@ -252,9 +277,16 @@ LLVMMetadataRef LLVMDIBuilderCreateMemberType(LLVMDIBuilderRef d,
 {
   DIBuilder* pd = unwrap(d);
 
+#if PONY_LLVM >= 400
+  return wrap(pd->createMemberType(unwrap<DIScope>(scope), name,
+    unwrap<DIFile>(file), line, size_bits, static_cast<uint32_t>(align_bits),
+    offset_bits, flags ? DINode::FlagPrivate : DINode::FlagZero, 
+    unwrap<DIType>(type)));
+#else
   return wrap(pd->createMemberType(unwrap<DIScope>(scope), name,
     unwrap<DIFile>(file), line, size_bits, align_bits,
     offset_bits, flags, unwrap<DIType>(type)));
+#endif
 }
 
 LLVMMetadataRef LLVMDIBuilderCreateArrayType(LLVMDIBuilderRef d,
@@ -263,7 +295,7 @@ LLVMMetadataRef LLVMDIBuilderCreateArrayType(LLVMDIBuilderRef d,
 {
   DIBuilder* pd = unwrap(d);
 
-  return wrap(pd->createArrayType(size_bits, align_bits,
+  return wrap(pd->createArrayType(size_bits, static_cast<uint32_t>(align_bits),
     unwrap<DIType>(elem_type), DINodeArray(unwrap<MDTuple>(subscripts))));
 }
 
diff --git a/src/libponyc/codegen/gendesc.c b/src/libponyc/codegen/gendesc.c
index b0994f9516..f3ecba3631 100644
--- a/src/libponyc/codegen/gendesc.c
+++ b/src/libponyc/codegen/gendesc.c
@@ -44,7 +44,6 @@ static LLVMValueRef make_unbox_function(compile_t* c, reach_type_t* t,
   LLVMGetParamTypes(f_type, params);
   LLVMTypeRef ret_type = LLVMGetReturnType(f_type);
 
-  const char* box_name = genname_box(t->name);
   const char* unbox_name = genname_unbox(m->full_name);
   compile_type_t* c_t = (compile_type_t*)t->c_type;
 
@@ -70,9 +69,14 @@ static LLVMValueRef make_unbox_function(compile_t* c, reach_type_t* t,
   LLVMValueRef primitive_ptr = LLVMBuildStructGEP(c->builder, this_ptr, 1, "");
   LLVMValueRef primitive = LLVMBuildLoad(c->builder, primitive_ptr, "");
 
+  const char* box_name = genname_box(t->name);
   LLVMValueRef metadata = tbaa_metadata_for_box_type(c, box_name);
+#if PONY_LLVM >= 400
+  tbaa_tag(c, metadata, primitive);
+#else
   const char id[] = "tbaa";
   LLVMSetMetadata(primitive, LLVMGetMDKindID(id, sizeof(id) - 1), metadata);
+#endif
 
   primitive = gen_assign_cast(c, c_t->use_type, primitive, t->ast_cap);
 
@@ -414,7 +418,6 @@ void gendesc_init(compile_t* c, reach_type_t* t)
   uint32_t event_notify_index = reach_vtable_index(t, c->str__event_notify);
 
   LLVMValueRef args[DESC_LENGTH];
-
   args[DESC_ID] = LLVMConstInt(c->i32, t->type_id, false);
   args[DESC_SIZE] = LLVMConstInt(c->i32, c_t->abi_size, false);
   args[DESC_FIELD_COUNT] = make_field_count(c, t);
diff --git a/src/libponyc/codegen/genexpr.c b/src/libponyc/codegen/genexpr.c
index 06d7aaae0e..9b2bd79a9f 100644
--- a/src/libponyc/codegen/genexpr.c
+++ b/src/libponyc/codegen/genexpr.c
@@ -32,9 +32,13 @@ LLVMValueRef gen_expr(compile_t* c, ast_t* ast)
       break;
 
     case TK_TUPLEELEMREF:
-      ret = gen_tupleelemptr(c, ast);
+    {
+      ast_t* s_type;
+      uint32_t index;
+      ret = gen_tupleelemptr(c, ast, &s_type, &index);
       break;
-
+    }
+    
     case TK_EMBEDREF:
       ret = gen_fieldembed(c, ast);
       break;
diff --git a/src/libponyc/codegen/genoperator.c b/src/libponyc/codegen/genoperator.c
index 9ff2a44dd7..a57f5986c2 100644
--- a/src/libponyc/codegen/genoperator.c
+++ b/src/libponyc/codegen/genoperator.c
@@ -345,6 +345,9 @@ static LLVMValueRef assign_local(compile_t* c, LLVMValueRef l_value,
 static LLVMValueRef assign_field(compile_t* c, LLVMValueRef l_value,
   LLVMValueRef r_value, ast_t* p_type, ast_t* l_type, ast_t* r_type)
 {
+  (void)(s_type); // these are for unfinished TBAA work
+  (void)(index);
+
   reach_type_t* t = reach_type(c->reach, l_type);
   pony_assert(t != NULL);
   compile_type_t* c_t = (compile_type_t*)t->c_type;
@@ -359,11 +362,17 @@ static LLVMValueRef assign_field(compile_t* c, LLVMValueRef l_value,
 
   // Store to the field.
   LLVMValueRef store = LLVMBuildStore(c->builder, r_value, l_value);
-
   LLVMValueRef metadata = tbaa_metadata_for_type(c, p_type);
+
+#if PONY_LLVM >= 400
+  tbaa_tag(c, metadata, result);
+  tbaa_tag(c, metadata, store);
+#else
   const char id[] = "tbaa";
-  LLVMSetMetadata(result, LLVMGetMDKindID(id, sizeof(id) - 1), metadata);
-  LLVMSetMetadata(store, LLVMGetMDKindID(id, sizeof(id) - 1), metadata);
+  unsigned md_kind = LLVMGetMDKindID(id, sizeof(id) - 1);
+  LLVMSetMetadata(result, md_kind, metadata);
+  LLVMSetMetadata(store, md_kind, metadata);
+#endif
 
   return gen_assign_cast(c, c_t->use_type, result, l_type);
 }
@@ -462,7 +471,9 @@ static LLVMValueRef assign_rvalue(compile_t* c, ast_t* left, ast_t* r_type,
     case TK_TUPLEELEMREF:
     {
       // The result is the previous value of the tuple element.
-      LLVMValueRef l_value = gen_tupleelemptr(c, left);
+      ast_t* s_type;
+      uint32_t index;
+      LLVMValueRef l_value = gen_tupleelemptr(c, left, &s_type, &index);
       ast_t* p_type = ast_type(ast_child(left));
       ast_t* l_type = ast_type(left);
       return assign_field(c, l_value, r_value, p_type, l_type, r_type);
diff --git a/src/libponyc/codegen/genopt.cc b/src/libponyc/codegen/genopt.cc
index 41d390f31d..aef42ee65c 100644
--- a/src/libponyc/codegen/genopt.cc
+++ b/src/libponyc/codegen/genopt.cc
@@ -1441,7 +1441,11 @@ bool target_is_x86(char* t)
 {
   Triple triple = Triple(t);
 
+#if PONY_LLVM >= 400
+  const char* arch = Triple::getArchTypePrefix(triple.getArch()).data();
+#else
   const char* arch = Triple::getArchTypePrefix(triple.getArch());
+#endif
 
   return !strcmp("x86", arch);
 }
@@ -1450,7 +1454,11 @@ bool target_is_arm(char* t)
 {
   Triple triple = Triple(t);
 
+#if PONY_LLVM >= 400
+  const char* arch = Triple::getArchTypePrefix(triple.getArch()).data();
+#else
   const char* arch = Triple::getArchTypePrefix(triple.getArch());
+#endif
 
   return !strcmp("arm", arch);
 }
diff --git a/src/libponyc/codegen/genprim.c b/src/libponyc/codegen/genprim.c
index d1fbe5423b..8b8887c80e 100644
--- a/src/libponyc/codegen/genprim.c
+++ b/src/libponyc/codegen/genprim.c
@@ -216,8 +216,12 @@ static void pointer_apply(compile_t* c, void* data, token_id cap)
   ast_setid(tcap, cap);
 
   LLVMValueRef metadata = tbaa_metadata_for_type(c, t->ast);
+#if PONY_LLVM >= 400
+  tbaa_tag(c, metadata, result);
+#else
   const char id[] = "tbaa";
   LLVMSetMetadata(result, LLVMGetMDKindID(id, sizeof(id) - 1), metadata);
+#endif
 
   ast_setid(tcap, tmp_cap);
 
@@ -252,9 +256,14 @@ static void pointer_update(compile_t* c, reach_type_t* t,
   LLVMValueRef store = LLVMBuildStore(c->builder, value, loc);
 
   LLVMValueRef metadata = tbaa_metadata_for_type(c, t->ast);
+#if PONY_LLVM >= 400
+  tbaa_tag(c, metadata, result);
+  tbaa_tag(c, metadata, store);
+#else
   const char id[] = "tbaa";
   LLVMSetMetadata(result, LLVMGetMDKindID(id, sizeof(id) - 1), metadata);
   LLVMSetMetadata(store, LLVMGetMDKindID(id, sizeof(id) - 1), metadata);
+#endif
 
   result = gen_assign_cast(c, c_t_elem->use_type, result, t_elem->ast_cap);
   LLVMBuildRet(c->builder, result);
@@ -358,8 +367,12 @@ static void pointer_delete(compile_t* c, reach_type_t* t,
   LLVMValueRef result = LLVMBuildLoad(c->builder, elem_ptr, "");
 
   LLVMValueRef metadata = tbaa_metadata_for_type(c, t->ast);
+#if PONY_LLVM >= 400
+  tbaa_tag(c, metadata, result);
+#else
   const char id[] = "tbaa";
   LLVMSetMetadata(result, LLVMGetMDKindID(id, sizeof(id) - 1), metadata);
+#endif
 
   LLVMValueRef src = LLVMBuildInBoundsGEP(c->builder, elem_ptr, &n, 1, "");
   src = LLVMBuildBitCast(c->builder, src, c_t->use_type, "");
diff --git a/src/libponyc/codegen/genreference.c b/src/libponyc/codegen/genreference.c
index 7c5c9792fa..944060ce84 100644
--- a/src/libponyc/codegen/genreference.c
+++ b/src/libponyc/codegen/genreference.c
@@ -63,9 +63,10 @@ static LLVMValueRef make_fieldptr(compile_t* c, LLVMValueRef l_value,
   pony_assert(ast_id(l_type) == TK_NOMINAL);
   pony_assert(ast_id(right) == TK_ID);
 
-  ast_t* def = (ast_t*)ast_data(l_type);
-  ast_t* field = ast_get(def, ast_name(right), NULL);
-  int index = (int)ast_index(field);
+  ast_t* def;
+  ast_t* field;
+  uint32_t index;
+  get_fieldinfo(l_type, right, &def, &field, &index);
 
   if(ast_id(def) != TK_STRUCT)
     index++;
@@ -104,9 +105,14 @@ LLVMValueRef gen_fieldload(compile_t* c, ast_t* ast)
   compile_type_t* c_t = (compile_type_t*)t->c_type;
 
   field = LLVMBuildLoad(c->builder, field, "");
+
   LLVMValueRef metadata = tbaa_metadata_for_type(c, ast_type(left));
+#if PONY_LLVM >= 400
+  tbaa_tag(c, metadata, field);
+#else
   const char id[] = "tbaa";
   LLVMSetMetadata(field, LLVMGetMDKindID(id, sizeof(id) - 1), metadata);
+#endif
 
   return gen_assign_cast(c, c_t->use_type, field, type);
 }
@@ -123,15 +129,16 @@ LLVMValueRef gen_fieldembed(compile_t* c, ast_t* ast)
 }
 
 static LLVMValueRef make_tupleelemptr(compile_t* c, LLVMValueRef l_value,
-  ast_t* l_type, ast_t* right)
+  ast_t* l_type, ast_t* right, uint32_t* index)
 {
   pony_assert(ast_id(l_type) == TK_TUPLETYPE);
-  int index = (int)ast_int(right)->low;
+  *index = (int)ast_int(right)->low;
 
-  return LLVMBuildExtractValue(c->builder, l_value, index, "");
+  return LLVMBuildExtractValue(c->builder, l_value, *index, "");
 }
 
-LLVMValueRef gen_tupleelemptr(compile_t* c, ast_t* ast)
+LLVMValueRef gen_tupleelemptr(compile_t* c, ast_t* ast, ast_t** l_type,
+  uint32_t* index)
 {
   AST_GET_CHILDREN(ast, left, right);
 
diff --git a/src/libponyc/codegen/genreference.h b/src/libponyc/codegen/genreference.h
index cbbca5a03e..6c7f6f16a6 100644
--- a/src/libponyc/codegen/genreference.h
+++ b/src/libponyc/codegen/genreference.h
@@ -16,7 +16,8 @@ LLVMValueRef gen_fieldload(compile_t* c, ast_t* ast);
 
 LLVMValueRef gen_fieldembed(compile_t* c, ast_t* ast);
 
-LLVMValueRef gen_tupleelemptr(compile_t* c, ast_t* ast);
+LLVMValueRef gen_tupleelemptr(compile_t* c, ast_t* ast, ast_t** l_type, 
+  uint32_t* index);
 
 LLVMValueRef gen_tuple(compile_t* c, ast_t* ast);
 
diff --git a/src/libponyc/codegen/gentype.c b/src/libponyc/codegen/gentype.c
index b20d4036e7..0ce59f0e56 100644
--- a/src/libponyc/codegen/gentype.c
+++ b/src/libponyc/codegen/gentype.c
@@ -19,11 +19,6 @@
 #include <stdlib.h>
 #include <string.h>
 
-static void compile_type_free(void* p)
-{
-  POOL_FREE(compile_type_t, p);
-}
-
 static size_t tbaa_metadata_hash(tbaa_metadata_t* a)
 {
   return ponyint_hash_ptr(a->name);
@@ -116,6 +111,32 @@ LLVMValueRef tbaa_metadata_for_box_type(compile_t* c, const char* box_name)
   return md->metadata;
 }
 
+void tbaa_tag(compile_t* c, LLVMValueRef metadata, LLVMValueRef instr)
+{
+  const char id[] = "tbaa";
+  unsigned md_kind = LLVMGetMDKindID(id, sizeof(id) - 1);
+
+  LLVMValueRef params[3];
+  params[0] = metadata;
+  params[1] = metadata;
+  params[2] = LLVMConstInt(c->i32, 0, false);
+
+  LLVMValueRef tag = LLVMMDNodeInContext(c->context, params, 3);
+  LLVMSetMetadata(instr, md_kind, tag);
+}
+
+void get_fieldinfo(ast_t* l_type, ast_t* right, ast_t** l_def,
+  ast_t** field, uint32_t* index)
+{
+  ast_t* d = (ast_t*)ast_data(l_type);
+  ast_t* f = ast_get(d, ast_name(right), NULL);
+  uint32_t i = (uint32_t)ast_index(f);
+
+  *l_def = d;
+  *field = f;
+  *index = i;
+}
+
 static LLVMValueRef make_tbaa_root(LLVMContextRef ctx)
 {
   const char str[] = "Pony TBAA";
@@ -123,7 +144,10 @@ static LLVMValueRef make_tbaa_root(LLVMContextRef ctx)
   return LLVMMDNodeInContext(ctx, &mdstr, 1);
 }
 
-static LLVMValueRef make_tbaa_descriptor(LLVMContextRef ctx, LLVMValueRef root)
+#if PONY_LLVM < 400
+
+static LLVMValueRef make_tbaa_descriptor(LLVMContextRef ctx, 
+  LLVMValueRef root)
 {
   const char str[] = "Type descriptor";
   LLVMValueRef params[3];
@@ -142,6 +166,13 @@ static LLVMValueRef make_tbaa_descptr(LLVMContextRef ctx, LLVMValueRef root)
   return LLVMMDNodeInContext(ctx, params, 2);
 }
 
+#endif
+
+static void compile_type_free(void* p)
+{
+  POOL_FREE(compile_type_t, p);
+}
+
 static void allocate_compile_types(compile_t* c)
 {
   size_t i = HASHMAP_BEGIN;
@@ -807,8 +838,7 @@ bool gentypes(compile_t* c)
     c->trait_bitmap_size = ((c->reach->trait_type_count + 63) & ~63) >> 6;
 
   c->tbaa_root = make_tbaa_root(c->context);
-  c->tbaa_descriptor = make_tbaa_descriptor(c->context, c->tbaa_root);
-  c->tbaa_descptr = make_tbaa_descptr(c->context, c->tbaa_root);
+
 
   allocate_compile_types(c);
   genprim_builtins(c);
diff --git a/src/libponyc/codegen/gentype.h b/src/libponyc/codegen/gentype.h
index e35d89c26f..5604082972 100644
--- a/src/libponyc/codegen/gentype.h
+++ b/src/libponyc/codegen/gentype.h
@@ -6,6 +6,27 @@
 
 PONY_EXTERN_C_BEGIN
 
+typedef struct tbaa_metadata_t
+{
+  const char* name;
+  LLVMValueRef metadata;
+} tbaa_metadata_t;
+
+DECLARE_HASHMAP(tbaa_metadatas, tbaa_metadatas_t, tbaa_metadata_t);
+
+tbaa_metadatas_t* tbaa_metadatas_new();
+
+void tbaa_metadatas_free(tbaa_metadatas_t* tbaa_metadatas);
+
+LLVMValueRef tbaa_metadata_for_type(compile_t* c, ast_t* type);
+
+LLVMValueRef tbaa_metadata_for_box_type(compile_t* c, const char* box_name);
+
+void tbaa_tag(compile_t* c, LLVMValueRef metadata, LLVMValueRef instr);
+
+void get_fieldinfo(ast_t* l_type, ast_t* right, ast_t** l_def,
+  ast_t** field, uint32_t* index);
+
 typedef struct compile_type_t
 {
   compile_opaque_free_fn free_fn;
@@ -37,22 +58,6 @@ typedef struct compile_type_t
   LLVMMetadataRef di_type_embed;
 } compile_type_t;
 
-typedef struct tbaa_metadata_t
-{
-  const char* name;
-  LLVMValueRef metadata;
-} tbaa_metadata_t;
-
-DECLARE_HASHMAP(tbaa_metadatas, tbaa_metadatas_t, tbaa_metadata_t);
-
-tbaa_metadatas_t* tbaa_metadatas_new();
-
-void tbaa_metadatas_free(tbaa_metadatas_t* tbaa_metadatas);
-
-LLVMValueRef tbaa_metadata_for_type(compile_t* c, ast_t* type);
-
-LLVMValueRef tbaa_metadata_for_box_type(compile_t* c, const char* box_name);
-
 bool gentypes(compile_t* c);
 
 PONY_EXTERN_C_END
diff --git a/src/libponyc/codegen/host.cc b/src/libponyc/codegen/host.cc
index 45929d9a57..0fb81b795f 100644
--- a/src/libponyc/codegen/host.cc
+++ b/src/libponyc/codegen/host.cc
@@ -222,6 +222,18 @@ void LLVMSetMetadataStr(LLVMValueRef val, const char* str, LLVMValueRef node)
     cast<Function>(v)->setMetadata(str, n);
 }
 
+void LLVMMDNodeReplaceOperand(LLVMValueRef parent, unsigned i, 
+  LLVMValueRef node)
+{
+  pony_assert(parent != NULL);
+  pony_assert(node != NULL);
+  pony_assert((int)i >= 0);
+
+  MDNode *pn = extractMDNode(unwrap<MetadataAsValue>(parent));
+  MDNode *cn = extractMDNode(unwrap<MetadataAsValue>(node));
+  pn->replaceOperandWith(i, cn);
+}
+
 LLVMValueRef LLVMMemcpy(LLVMModuleRef module, bool ilp32)
 {
   Module* m = unwrap(module);
diff --git a/wscript b/wscript
index 4fd539da94..f22a387ebe 100644
--- a/wscript
+++ b/wscript
@@ -42,6 +42,7 @@ MSVC_VERSIONS = [ '15', '14' ]
 
 # keep these in sync with the list in .appveyor.yml
 LLVM_VERSIONS = [
+    '4.0.0',
     '3.9.1',
     '3.8.1',
     '3.7.1'
